uses crt, mlkbd, mlfinty, G_Modes, graph, Mouse_Gr;


const MaxDlzka = 500;


type _clanok = record
                 X, Y: integer;
                 Telo: char;
                 Farba: byte;
               end;



var Ch: char;
    Klv: byte;
    Dlzka: byte;
    Smer: integer;  {0..360 stupnov}
    Clanok: array[1..MaxDlzka] of _clanok;
    I, J, K, L: byte;
    pX, pY, MaxX, MaxY: integer;
    rX, rY: real;


procedure Nakresli;
begin
  for I := 1 to Dlzka do with Clanok[i] do
    begin
      PutPixel(X, Y, Farba);
      PutPixel(X, Y - 1, 1);
      PutPixel(X, Y + 1, 1);
    end;

  PutPixel(pX, pY, 0);
  PutPixel(pX, pY+1, 0);
  PutPixel(pX, pY-1, 0);

end;


function JeV(A, B, C: integer): boolean;
begin
  JeV := false;
  if (A <= B) and (B <= C) then JeV := true;
end;


procedure doHusenica;
begin
     with Clanok[Dlzka] do
       begin
        pX := X;
        pY := Y;
      end;

    for i := Dlzka downto 2 do with Clanok[i] do
      begin
        X := Clanok[i - 1].X;
        Y := Clanok[i - 1].Y;
      end;



    with Clanok[1] do
      begin
        rX := rX + sin(Smer * Pi / 180);
        rY := rY - cos(Smer * Pi / 180);

        X := Trunc(rX);
        Y := Trunc(rY);

        if X = MaxX then
          begin
            X := MaxX - 1;
            Inc(Y);
            Smer := 2;
          end;

        if Y = MaxY then
          begin
            Y := MaxY - 1;
            Dec(X);
            Smer := 4;
          end;

        if X = 0 then
          begin
            X := 1;
            Dec(Y);
            Smer := 8;
          end;

        if Y = 0 then
          begin
            Y := 1;
            Inc(X);
            Smer := 6;
          end;
      end;

{    for I := 1 to Dlzka do for J := 1 to Dlzka do
      begin
        if (Clanok[J].X = Clanok[I].X) and
           (Clanok[J].Y = Clanok[I].Y) and
           (I <> J) then Clanok[I].Farba := 4;
      end; }
end;




procedure SmerovaSipka;
var sX, sY, dX, dY: integer;
begin
  sX := MaxX - 50;
  sY := 50;

  dX := sX + Trunc(40 * sin(Smer * Pi / 180));
  dY := sY - Trunc(40 * cos(Smer * Pi / 180));

  SetColor(2);
  Circle(sX, sY, 40);
  SetFillStyle(0, 0);
  FloodFill(sX, sY, 2);
  Circle(sX, sY, 3);

  SetColor(4);
  Line(sX, sY, dX, dY);
end;




begin

  _Vga;


  Dlzka := 250;
  Smer := 90;
  MaxX := GetMaxX;
  MaxY := GetMaxY;
  rX := MaxX div 2 + Dlzka div 2;
  rY := MaxY div 2;



  for I := 1 to Dlzka do with Clanok[I] do
    begin
      X := Trunc(rX) + 1 - i;
      Y := Trunc(rY);
      Telo := '*';
      Farba := 1;
    end;
  Clanok[1].Telo := 'X';


  Nakresli;
  SmerovaSipka;

  repeat

    if Keypressed then
      begin
        Ch := Readkey;
        Klv := Klavesa(Ch);


        case klv of
          8: dec(Smer, 5);
          2: inc(Smer, 5);
          4: inc(Smer, 5);
          6: dec(Smer, 5);
        end;

        if Smer > 360 then Dec(Smer, 360);
        if Smer < -360 then Inc(Smer, 360);

      end;


    doHusenica;

    SmerovaSipka;
    Nakresli;

    Delay(5);

  until Ch=#27;

end.
