unit MLdos;  {marek laco 21. august 1996 - zalozeny}
             {20. sept. 1996 - upraveny}
{ pre pracu so subormi }
{cislovanie diskov - vc procedury a fcie}
{ a: -- 0}
{ b: -- 1}
{ c: -- 2}
{ d: -- 3}
{ e: -- 4}
{ f: -- 5}

interface
  function FileExist(FileName: string): boolean;
  {zisti ci v aktualnom ADResari je subor, mozes napisat aj plnu cestu k nemu}
  function DirExist(Path: string): boolean;
  {zisti ci je taky adresar c:\pascal\marek\units => true}
  function FileExt(FileName: string): string;
  {vrati priponu z celeho mena suboru, bez cesty; nc.exe => exe}
  function FileName(FileName_w_e: string): string;
  {vrati iba nazov bez pripony z celeho mena suboru, bez cesty; nc.exe => nc}
  function FileName_from_path(Path: string): string;
  {vrati cele meno suboru z cesty napr.: c:\dos\fdisk.exe => fdisk.exe }
  function Path(Path_w_n: string): string;
  {vrati cestu z cesty s menom napr.: c:\dos\fdisk.exe => c:\dos; c:\a.a => c:\}
  function FileNameExist(_file: string): boolean;
  {ci existuje daky fajl, ktori specifikujes bez pripony}
  function FileVelkost(FName: string): longint;
  {vrati velkost suboru v byteoch, ak nieje tak -1}
  {--------------------------------------------------------------}
  procedure Abord(Message: string);
  {zahlasi spravu a skonci program}
  procedure Execute(Prog: string);
  {spusti zadany program, pozor aby to islo musi byt {$M 16...,0...,0...}
  function Podporuje(drive: byte): boolean;
  {ak jednotka je schopna detektovat zmenu diskety tek TRUE}
  function GetVolumeLabel(Drive: byte): string;
  {vrati Label disku}
  function NewDisk(Drive: byte): boolean;
  {ci je nova disketa v drive}
  function JeDisketaV(Drive: byte): boolean;
  {ci je vuobec disketa v drive}
  function GetDisk: byte;
  {vrati aktualny disk}
  procedure SetDisk(Drive: byte);
  {nastavy disk}
  function Velkost(Velk: longint): string;
  {velkost v byteoch vrati v MB, alebo v KB;  1400466 => 1.40 MB }
  function SetFileAttr(SuborName: string; Attr: word): byte;
  {nastavy dos atributy Suboru [c:\aaa.ddd] podla premennej [archive + readonly] }
  {ak chyba tak vrati ine cisto, ako 0}
  procedure GetFileAttr(SuborName: string; var Atr: word; var A, R, H, S: boolean);
  {do premennych da atributy ARHS}



implementation

uses dos, graph;

function FileExist(FileName: string): boolean;
var S: PathStr;
begin
  S := FSearch(FileName, '');
  if S = '' then FileExist := FALSE else FileExist := TRUE;
end;




function DirExist(Path: string): boolean;
var HomeDir: string;
begin
  GetDir(0, HomeDir);
  {$I-}
  ChDir(Path);
  {$I+}
  if IOresult = 0 then DirExist := TRUE
   else DirExist := FALSE;
  ChDir(HomeDir);
end;

function FileExt(FileName: string): string;
var i: byte;
begin
  i := Pos('.', FileName);
  if (i = 0) or (i = Length(FileName)) then FileExt := '' else
   FileExt := Copy(FileName, i + 1, Length(FileName) - i);
end;

function FileName(FileName_w_e: string): string;
var i: byte;
begin
  i := Pos('.', FileName_w_e);
  if i = 0 then i := Length(FileName_w_e) + 1;
  FileName := Copy(FileName_w_e, 1, i - 1);
end;

function FileName_from_path(Path: string): string;
var i: byte;
begin
  i := Length(Path);
  if i = 0 then Writeln('Co za Path?');
  while (Path[i] <> '\') and (Path[i] <> ':') and (i > 0) do Dec(i);
  FileName_from_Path := Copy(Path, i + 1, Length(Path) - i);
end;

function Path(Path_w_n: string): string;
var i: byte; St: string;
begin
  i := Length(Path_w_n);
  if i = 0 then Writeln('Co za Path?');
  while (Path_w_n[i] <> '\') and (Path_w_n[i] <> ':') and (i > 0) do Dec(i);
  St := Copy(Path_w_n, 1, i - 1);
  if Length(St) = 2 then St := St + '\'; {c: => c:\}
  Path := St;
end;




function FileNameExist(_file: string): boolean;
var Search: searchrec;
begin
  FileNameExist := FALSE;
  FindFirst(FileName(_File) + '.*', $3f, Search);
  if DosError = 0 then FileNameExist := TRUE;
end;



procedure Abord(Message: String);
begin
  Closegraph;
  Writeln;
  Writeln('FATAL ERROR: ', Message, '  !!!');
  Writeln;
  Halt(255);
end;

procedure Execute(Prog: string);
begin
  SwapVectors;
  Exec(GetEnv('comspec'), ' /c ' + Prog);
  SwapVectors;
end;


function Podporuje(drive: byte): boolean;
{ak jednotka je schopna detektovat zmenu diskety tek TRUE}
var r: registers;
begin
  Podporuje := FALSE;
  r.ah := $15;
  r.dl := drive;
  intr($13, r);
  if r.ah = 2 then Podporuje := TRUE
end;


procedure SetDisk(Drive: byte);
begin
  asm
    mov ah, 0eh
    mov dl, Drive
    int 21h
  end;
end;

function GetDisk: byte;
begin
  asm
    mov ah, 19h
    int 21h
    mov @result, al
  end;
end;

function GetVolumeLabel(Drive: byte): string;
var Search: searchrec; I: byte; St: string;
begin
  SetDisk(Drive);
  FindFirst('*.*', VolumeID ,Search);
  St:= search.Name;
  i := pos('.', St);  {kde je bodka}
  Delete(St, i, 1);   {prec s bodkou!}
  GetVolumeLabel := St;
end;

function NewDisk(Drive: byte): boolean;
var r: registers;
begin
  NewDisk := FALSE;
  r.ah := $16;
  r.dl := Drive;
  intr($13, r);
  if r.ah = 6 then NewDisk := TRUE;
end;

function JeDisketaV(Drive: byte): boolean;
var Homedir: string;
begin
  JeDisketaV := FALSE;
  GetDir(0, Homedir);
  SetDisk(Drive);
  if DiskSize(0) > 0 then JeDisketaV := TRUE;
  ChDir(Homedir);
end;



function Velkost(Velk: longint): string;
var St, Prip: string; Cs: real; del, vlkst: longint;
begin
  vlkst := 1000;  {1024}
  if Velk >= (vlkst*vlkst) then begin Del := (vlkst * vlkst); Prip := 'MB' end
   else begin Del := 1024; Prip := 'KB'; end;
  Cs := Velk / Del;
  Str(Cs:3:2, St);
  if (St = '1.46') and (Velk < 1457664) then St := '1.45';
  St := St + ' ' + Prip;
  Velkost := St;
end;


function SetFileAttr(SuborName: string; Attr: word): byte;
var Subor: file;
begin
  Assign(Subor, SuborName);
  SetFAttr(Subor, Attr);
  SetFileAttr := DosError;
end;

procedure GetFileAttr(SuborName: string; var Atr: word; var A, R, H, S: boolean);
var Attr: Word; Subor: file;
begin
  A := FALSE;
  R := FALSE;
  H := FALSE;
  S := FALSE;
  Assign(Subor, SuborName);
  GetFAttr(Subor, Attr);
  if DosError <> 0 then Writeln('GetFileAttr: DOS error code = ', DosError)
   else
   begin
     Atr := Attr;
     if Attr and ReadOnly <> 0 then R := TRUE;
     if Attr and Hidden <> 0 then H := TRUE;
     if Attr and SysFile <> 0 then S := TRUE;
     if Attr and Archive <> 0 then A := TRUE;
   end;
end;

function FileVelkost(FName: string): longint;
var search: searchrec;
begin
  FindFirst(Fname, $ef, search);
  FileVelkost := search.size;
  if doserror <> 0 then FileVelkost := -1;
end;



end.



