unit MLkbd; {zalozene z pouvodnych materialov 14.9.1996 12:31 pm}
            {pre pracu s klavesnicou a status kbd}
            { by Marek Laco(tm) 1996 }

interface
  function Klavesa(Ch: char): byte;
  {vrati stlacenu klavesu - sipku na numpade podla cisla //hore = 8}
  {fn klavesi F1 = 101 .. F10 = 110}
  function SHIFT: boolean;  { ci je stlaceny shift}
  function LSHIFT: boolean; { ci je stlaceny lavy shift}
  function RSHIFT: boolean; { ci je stlaceny pravy shift}
  function CTRL: boolean;   { ci je stlaceny control}
  function ALT: boolean;    { ci je stlaceny alt}
  function CAPS: boolean;   { ci je prepnuty caps lock}
  function SCROLL: boolean; { ci je prepnuty scroll lock}
  function INS: boolean;    { ci je prepnuty insert}
  function NUM: boolean;    { ci je prepnuty num lock}

implementation

var KBDst: byte absolute $0:$0417;  {pre preradovace klav.}

function Klavesa(Ch: char): byte;
var K: Byte;
begin
 case Ch of
  #59: K := 101;  { F1 }
  #60: K := 102;  { F2 }
  #61: K := 103;  { F3 }
  #62: K := 104;  { F4 }
  #63: K := 105;  { F5 }
  #64: K := 106;  { F6 }
  #65: K := 107;  { F7 }
  #66: K := 108;  { F8 }
  #67: K := 109;  { F9 }
  #68: K := 110;  { F10}
  #72: K := 8;
  #80: K := 2;
  #75: K := 4;
  #77: K := 6;
  #71: K := 7;
  #73: K := 9;
  #79: K := 1;
  #81: K := 3;
  #82: K := 0;  { ins }
  #83: K := 11; { del }
   #8: K := 108; { bs  }
   #9: K := 109; { tab }
  else K := Ord(Ch);
 end;
 Klavesa := K;
end;

function LSHIFT: boolean; { ci je stlaceny lavy shift}
begin
  if KBDst and 2 = 2 then LSHIFT := TRUE else LSHIFT := FALSE;
end;

function RSHIFT: boolean; { ci je stlaceny pravy shift}
begin
  if KBDst and 1 = 1 then RSHIFT := TRUE else RSHIFT := FALSE;
end;

function SHIFT: boolean;  { ci je stlaceny shift}
begin
 if (LSHIFT or RSHIFT) then SHIFT := TRUE else SHIFT := FALSE;
end;


function CTRL: boolean;   { ci je stlaceny control}
begin
  if KBDst and 4 = 4 then CTRL := TRUE else CTRL := FALSE;
end;

function ALT: boolean;    { ci je stlaceny alt}
begin
  if KBDst and 8 = 8 then ALT := TRUE else ALT := FALSE;
end;

function CAPS: boolean;   { ci je prepnuty caps lock}
begin
  if KBDst and 64 = 64 then CAPS := TRUE else CAPS := FALSE;
end;

function SCROLL: boolean; { ci je prepnuty scroll lock}
begin
  if KBDst and 16 = 16 then SCROLL := TRUE else SCROLL := FALSE;
end;

function INS: boolean;    { ci je prepnuty insert}
begin
  if KBDst and 128 = 128 then INS := TRUE else INS := FALSE;
end;

function NUM: boolean;    { ci je prepnuty num lock}
begin
  if KBDst and 32 = 32 then NUM := TRUE else NUM := FALSE;
end;

end.