unit MouseTXT;       { marek laco }

interface
  procedure MoOn;
  procedure MoOff;
  function GetMoX: word;
  function GetMoY: word;
  procedure SetMoX(X: word);
  procedure SetMoY(Y: word);
  procedure SetMoXY(X, Y: word);
  function MoButt: byte;
implementation

uses Dos, Crt;

var r: registers;
    X, Y: word;
    Butt: byte;
    Ch: Char;

procedure MoOn;       { mouse cursor on}
begin
  r.ax := 1;
  Intr($33, r);
end;

procedure MoOff;       { mouse cursor off}
begin
  r.ax := 2;
  Intr($33, r);
end;

function GetMoX: word;
begin
  r.ax := 3;
  Intr($33, r);
  GetMoX := r.cx div 8 + 1;
end;

function GetMoY: word;
begin
  r.ax := 3;
  Intr($33, r);
  GetMoY := r.dx div 8 + 1;
end;

procedure SetMoX(X: word);
begin
  r.cx := (X - 1) * 8;
  r.ax := $04;
  Intr($33, r);
end;

procedure SetMoY(Y: word);
begin
  r.dx := (Y - 1) * 8;
  r.ax := $04;
  Intr($33, r);
end;

procedure SetMoXY(X, Y: word);
begin
  r.cx := (X - 1) * 8;
  r.dx := (Y - 1) * 8;
  r.ax := 4;
  Intr($33, r);
end;


function MoButt: byte;   { mouse  buttons }
begin
  r.ax := 3;
  Intr($33, r);
  MoButt := 0;
  if not (r.bx and 1 = 0) then MoButt := 1;
  if not (r.bx and 4 = 0) then MoButt := 2;
  if not (r.bx and 2 = 0) then MoButt := 3;
end;

end.