uses dos, crt, graph, mouse, MLgrf, G_Modes;

var MaxX, X, PomX, OldX: _X;
    MaxY, Y, PomY, OldY: _Y;
    KurF2, CiarF, RamF, KurF, Color, Speed, I, J, K, L  : word;
    KurF3, KurF4: word;
    PrieF: word;
    Ch: char;

    Postup, Uhol: word;
  u, v, c, c1: integer;
  x1, y1, x2, y2: array[1..8] of integer;
  x1c, y1c, x2c, y2c: array[1..8] of integer;



procedure Set_var;
begin
  MaxX := GetMaxX;
  MaxY := GetMaxY;
  X := MaxX div 2;
  Y := MaxY div 2;
  OldX := X;
  OldY := Y;
  Speed := 30;
  Ch := #0;

  KurF := 29;
  KurF2 := 44;
  KurF3 := 66;
  KurF4 := 119;

  CiarF := 253;
  RamF := 220;

  PrieF := 115;

  Uhol := 0;
  Postup := 0;

  c1 := 22;
  c := 5;
  u := 20;
  v := 8;



end;

procedure Instal_Vga;
begin
  Svga800;
  LoadPal('VGA.PAL');
  Color := 255;
  SetColor(Color);

end;

procedure Instal_Mys;
begin
  Mouseinstall;
  MouseInit(0, 0, MaxX, MaxY, Speed, Speed);
  MouseCursor(4);
  MousePos(X, Y);
end;


procedure MysKurzor;
  procedure NakresliC(X: _X; Y: _Y);
  begin
    Circle(X, Y, c);
    Circle(X, Y, c1);
    Ellipse(X, Y, 0, 360, u, v);
    Ellipse(X, Y, 0, 360, v, u);
    PutPixel(X, Y, 0);
  end;

  procedure Nakresli(X: _X; Y: _Y);
  begin
    SetColor(KurF4);
    Ellipse(X, Y, 360 - Uhol, Uhol, c, c);
    Ellipse(X, Y, 360 - Uhol, Abs(180 - Uhol), c1, c1);

    SetColor(KurF2);
    Ellipse(X, Y, (220 + Uhol) mod 360, Uhol, u, v);
    Ellipse(X, Y, (220 + Uhol) mod 360, Uhol, v, u);

    SetColor(KurF3);
    Ellipse(X, Y, Uhol, 360 - Uhol, c, c);
    Ellipse(X, Y, Abs(180 - Uhol), 360 - Uhol, c1, c1);

    SetColor(KurF);
    Ellipse(X, Y, Uhol, (220 + Uhol) mod 360, u, v);
    Ellipse(X, Y, Uhol, (220 + Uhol) mod 360, v, u);

    PutPixel(X, Y, 255);
  end;
begin
  SetColor(0);
  if (OldX <> X) or (OldY <> Y) then NakresliC(OldX, OldY);

  Nakresli(X, Y);
end;


function VypocX(Cislo: word): _X;
var Pom: _X;
begin
  Cislo := Cislo mod (2 * MaxX + 2 * MaxY);
  if Cislo <= MaxY then Pom := 1
   else if Cislo <= MaxX + MaxY then Pom := Cislo - MaxY
    else if Cislo <= MaxX + 2 * MaxY then Pom := MaxX - 1
     else Pom := MaxX - (Cislo - (2 * MaxY + MaxX));
  VypocX := Pom;
end;

function VypocY(Cislo: word): _Y;
var Pom: _Y;
begin
  Cislo := Cislo mod (2 * MaxX + 2 * MaxY);
  if Cislo <= MaxY then Pom := Cislo
   else if Cislo <= MaxX + MaxY then Pom := MaxY - 1
    else if Cislo <= MaxX + 2 * MaxY then Pom := MaxY - (Cislo - (MaxY + MaxX))
     else Pom := 1;
  VypocY := Pom;
end;


procedure Ciary;
var n: integer;

  procedure Nakresli(X: _X; Y: _Y; Po: word);
  var t: word; uhol: array[1..8] of real;
  begin
    t := 2 * MaxX + 2 * MaxY;

    for i := 0 to 7 do
      begin
        X1[i + 1] := VypocX(Po + i * (t div 8));
        Y1[i + 1] := VypocY(Po + i * (t div 8));
      end;

    for i := 0 to 7 do
      begin
        Uhol[i + 1] := (((Po  / t) * 360)) + 45 + i * 45;
      end;

    for i := 1 to 8 do
      begin
        X2[i] := X - Trunc((c1 + 1) * Sin(Uhol[i] * Pi / 180));
        Y2[i] := Y - Trunc((c1 + 1) * Cos(Uhol[i] * Pi / 180));   ;
      end;

    for i := 1 to 8 do Line(X1[i], Y1[i], X2[i], Y2[i]);

  end;

  procedure NakresliC(X: _X; Y: _Y; Po: word);
  var t: word; uhol: array[1..8] of real;
  begin
    t := 2 * MaxX + 2 * MaxY;

    for i := 0 to 7 do
      begin
        X1c[i + 1] := VypocX(Po + i * (t div 8));
        Y1c[i + 1] := VypocY(Po + i * (t div 8));
      end;

    for i := 0 to 7 do
      begin
        Uhol[i + 1] := (((Po  / t) * 360)) + 45 + i * 45;
      end;

    for i := 1 to 8 do
      begin
        X2c[i] := X - Trunc((c1 + 1) * Sin(Uhol[i] * Pi / 180));
        Y2c[i] := Y - Trunc((c1 + 1) * Cos(Uhol[i] * Pi / 180));   ;
      end;

    for i := 1 to 8 do Line(X1[i], Y1[i], X2[i], Y2[i]);

  end;

begin
{  n := 16;}



  SetColor(CiarF);
  Nakresli(X, Y, Postup);
  SetColor(0);
  NakresliC(OldX, OldY, Postup);

end;

procedure Priecky;
var  PrSur: array[1..9] of _Sur;
     PrSurC: array[1..9] of _Sur;
begin
  for i := 1 to 8 do
    begin
      PrSur[i].X := (X1[i] + X2[i]) div 2;
      PrSur[i].Y := (Y1[i] + Y2[i]) div 2;
      PrSurC[i].X := (X1[i] + X2[i]) div 2;
      PrSurC[i].Y := (Y1[i] + Y2[i]) div 2;

    end;

  PrSur[9] := PrSur[1];
  PrSurC[9] := PrSurC[1];

  SetColor(PrieF);
  for i := 1 to 8 do Line(PrSur[i].X,PrSur[i].Y,PrSur[i+1].X,PrSur[i+1].Y);
  SetColor(0);
  for i := 1 to 8 do Line(PrSurC[i].X,PrSurC[i].Y,PrSurC[i+1].X,PrSurC[i+1].Y);

end;



procedure Klavesy;
begin
  while Keypressed do
    begin
      Ch := Readkey;
    end;
end;

procedure Jadro;
begin
  repeat
    if KeyPressed then Klavesy;

    OldX := X;
    OldY := Y;
    X := MouseX;
    Y := MouseY;

    Inc(Uhol);
    if Uhol = 360 then Uhol := 0;

    Inc(Postup);
    if Postup = 2 * MaxX + 2 * MaxY then Postup := 0;

    {if (X <> OldX) or (Y <> OldY) then}
      begin
        MysKurzor;
        Ciary;
        Priecky;
      end;
  until ch = #27;
end;

procedure Priprava;
begin
  SetColor(RamF);
  Rectangle(0, 0, MaxX, MaxY);
  MysKurzor;
  Ciary;
end;

begin
  Instal_Vga;
  Set_Var;
  Instal_Mys;

  Priprava;
  Jadro;
end.

