uses dos, crt, graph, marek, g_modes, mouse_gr, inp;

type  _sur3d = record
                 X, Y, Z: integer;
               end;

var StrK: _Sur3d;
    I, J, K: byte;
    LD, Uhol: _Sur3d;  {lavydolny vrchol kocky}
    Vrch: array[1..8] of _Sur3d;
    PostVykr: string;
    MoX, MoY, OldMoX, OldMoY: integer;
    XXmoX, XXmoY: integer;
    Uholl: integer;
    Mode, Ch : char;
    r: real;


procedure SaveMo;
begin
  XXmoX := GetMoX;
  XXmoY := GetMoY;
end;

procedure RestoreMo;
begin
  SetMoX(XXmoX);
  SetMoY(XXmoY);
end;

procedure Line3d(X1, Y1, Z1, X2, Y2, Z2:integer);
begin
  Line(X1 + Z1 div 2, Y1 - Z1 div 2, X2 + Z2 div 2, Y2 - Z2 div 2);
end;

procedure Line3dX(Sur1, Sur2: _Sur3d);
begin
  Line3d(Sur1.X, Sur1.Y, Sur1.Z, Sur2.X, Sur2.Y, Sur2.Z);
end;


procedure DefKocku;
begin
  PostVykr := '122334415667788515263748';

  StrK.X := 100;
  StrK.Y := 100;
  StrK.Z := 100;

  LD.X := 100;
  LD.Y := 200;
  LD.Z := 0;

  Uhol.X := 0;
  Uhol.Y := 0;
  Uhol.Z := 0;
end;

procedure PocKocku;
begin
 { for I := 1 to 8 do Vrch[I] := LD;
  Inc(Vrch[2].X, StrK.X);
  Inc(Vrch[3].X, StrK.X); Inc(Vrch[3].Z, StrK.Z);
  Inc(Vrch[4].Z, StrK.Z);
  Dec(Vrch[5].Y, StrK.Y);
  Dec(Vrch[6].Y, StrK.Y); Inc(Vrch[6].X, StrK.X);
  Dec(Vrch[7].Y, StrK.Y); Inc(Vrch[7].X, StrK.X); Inc(Vrch[7].Z, StrK.Z);
  Dec(Vrch[8].Y, StrK.Y); Inc(Vrch[8].Z, StrK.Z); }

  r := sqrt(sqr(StrK.X div 2) + sqr(StrK.Y div 2));

  Vrch[1].X := Ld.X + Trunc( cos((225 + Uhol.X)*Pi/180) * r);
  Vrch[1].Y := Ld.Y + Trunc( sin((225 + Uhol.X)*Pi/180) * r);

  Vrch[2].X := Ld.X + Trunc( cos((315 + Uhol.X)*Pi/180) * r);
  Vrch[2].Y := Ld.Y + Trunc( sin((315 + Uhol.X)*Pi/180) * r);

  Vrch[3].X := Ld.X + Trunc( cos((45 + Uhol.X)*Pi/180) * r);
  Vrch[3].Y := Ld.Y + Trunc( sin((45 + Uhol.X)*Pi/180) * r);

  Vrch[4].X := Ld.X + Trunc( cos((135 + Uhol.X)*Pi/180) * r);
  Vrch[4].Y := Ld.Y + Trunc( sin((135 + Uhol.X)*Pi/180) * r);

end;

procedure VykrKocku;
var z1,z2: string; c1, c2: byte; code: integer;
begin
 I := 0;
 repeat
   z1 := PostVykr[I + 1];
   z2 := PostVykr[I + 2];
   Val(z1, c1, code);
   Val(z2, c2, code);
   Line3dX(Vrch[c1], Vrch[c2]);
   Inc(I, 2);
 until I >= Length(PostVykr);
end;

function Modus(M: char): integer;
begin
  case UpCase(M) of
    'X': Modus := Uhol.X;
    'Y': Modus := Uhol.Y;
    'Z': Modus := Uhol.Z;
    else Modus := 0;
  end;
end;

procedure ZapisUhol(M: char; U: integer);
begin
  case UpCase(M) of
    'X': Uhol.X := U;
    'Y': Uhol.Y := U;
    'Z': Uhol.Z := U;
  end;
end;

begin
  Mode := 'X';

  _vga;
  SetColor(14);

  DefKocku;
  PocKocku;
  VykrKocku;

  {Moon;}

  MoX := LD.X;
  MoY := LD.Y;
  SetMoX(MoX);
  SetMoY(MoY);

  repeat
    OldMoX := MoX;
    OldMoY := MoY;
    MoX := GetMoX;
    MoY := GetMoY;
    if Keypressed then
      begin
        Uholl := Modus(Mode);
        Ch := ReadKey;
        case UpCase(Ch) of
          'X': Mode := 'X';
          'Y': Mode := 'Y';
          'Z': Mode := 'Z';
          #09: if Mode = 'X' then Mode := 'Y' else if Mode = 'Y'
                  then Mode := 'Z' else Mode := 'Y';
          '+': Inc(Uholl, 3);
          '-': Dec(Uholl, 3);
        end;
        ZapisUhol(Mode,Uholl);

        SetColor(0); VykrKocku;
        PocKocku; SetColor(15); VykrKocku;
      end;

    if MoButt = 1 then
      begin
        SaveMo;
        SetMoX(StrK.X);
        SetMoY(GetMaxY - StrK.Y);
        Delay(100);
        repeat
          OldMoX := MoX;
          OldMoY := MoY;
          MoX := GetMoX;
          MoY := GetMoY;
          if (KeyPressed) and (readKey = #9) then
             if Mode = 'X' then Mode := 'Z' else Mode :='X';
          if (MoX <> OldMoX) or (MoY <> OldMoY) then
            begin
              SetColor(0); VykrKocku;
              if Mode = 'X' then StrK.X := GetMoX;
              if Mode = 'Z' then StrK.Z := GetMoX;
              StrK.Y := GetMaxY - GetMoY;
              PocKocku;
              SetColor(15); VykrKocku;
            end;
        until MoButt = 1;
        Delay(200);
        RestoreMo;
      end;

    if (MoX <> OldMoX) or (MoY <> OldMoY) then
      begin
        SetColor(0); VykrKocku;
        LD.x := MoX;
        LD.Y := MoY;
        PocKocku;
        SetColor(14); VykrKocku;
       end;
   until (Ch = #27) or (mobutt = 3);

   ClrKbd;
   Delay(100);
end.
