unit Mprinter;   { Marek Laco, september 1995, pre EPSON LQ }

interface
 function ON: Boolean;
 procedure E(Command: String);
 procedure ROM;
 procedure RAM;
 procedure ROMtoRAM;
 procedure P(Command: String);
 procedure Pln(Command: String);
 procedure Initialize;
 procedure LQ;
 procedure Draft;
implementation

uses Printer;

function ON: Boolean;
begin
 ON := TRUE;
 {$I-}
 Write(Lst,#27 + 'R' + #0);
 if IOresult <> 0 then ON := FALSE;
 {$I+}
end;


procedure E(Command: String);
begin
 Write(Lst, #27 + Command);
end;

procedure ROM;
begin
 if ON then E('%' + #0);
end;

procedure RAM;
begin
 if ON then E('%' + #1);
end;

procedure ROMtoRAM;
begin
 if ON then E(':' + #0 + #0 + #0);
end;

procedure P(Command: String);
begin
 Write(Lst, Command);
end;

procedure Pln(Command: String);
begin
 Writeln(Lst, Command);
end;

procedure Initialize;
begin
 if ON then E('@');
end;

procedure LQ;
begin
 if ON then E('x' + #1);
end;

procedure Draft;
begin
 if ON then E('x' + #0);
end;

end.