
uses crt,inp,marek;

{  Split2Static  }
procedure Split2Static;
var A:byte;
begin
  A:=Port[$3DA];                  { Attribute mode control }
  Port[$3C0]:=$10 or $20;
  Port[$3C0]:=Port[$3C1] or $20;
end;
{  SplitScreen  }
procedure SplitScr(N:integer);         { 1023..0 }
var A:byte;
begin             { Screen-up is Start addr high/low, -down is $B800 }
  Port[$3D4]:=$18; Port[$3D5]:=Lo(N);  { Bit 0-7, Line compare }
  Port[$3D4]:=$07; A:=Port[$3D5];      { Bit 8, Overflow }
  if N<$100 then A:=A and $EF else A:=A or $10;
  Port[$3D5]:=A;
  Port[$3D4]:=$09; A:=Port[$3D5];      { Bit 9, Maximum scan line }
  if N<$200 then A:=A and $BF else A:=A or $40;
  Port[$3D5]:=A;
end;
{  SetSize  }
procedure SetSize(X,Y:integer);
begin
  Port[$3D4]:=$13; Port[$3D5]:=X shr 1;
  MemW[0:$44A]:=X;
  MemW[0:$484]:=Y-1;
  MemW[0:$44C]:=X*Y;
end;
{  SetTextDisplay  }
procedure SetTextDisp(X,Y:integer);
var A:byte;
begin
  repeat until Port[$3DA] and 8<>8;
  repeat until Port[$3DA] and 8=8;
  Port[$3D4]:=$0C; Port[$3D5]:=Hi(Y shr 4*160+X div 9);  { Start XY addr }
  Port[$3D4]:=$0D; Port[$3D5]:=Lo(Y shr 4*160+X div 9);
  repeat until Port[$3DA] and 1<>1;
  repeat until Port[$3DA] and 1=1;
  Port[$3D4]:=$08; Port[$3D5]:=Port[$3D5] and $E0 or (Y and 15);
  A:=Port[$3DA];                                         { Horizental PEL }
  Port[$3C0]:=$13 or $20; Port[$3C0]:=(X+8) mod 9;
end;
{  Scroll  }
procedure Scroll;
var i,j: byte;X,Y,N:integer; ch: char;
begin
  SetSize(160,50);
  {SetSize(160,50);}

  X:=0;
  Y:=0;
  N:=2;

  SplitScr(400);
{  SplitScr(299);}
  Split2Static;

  for i := 1 to 24 do for j := 1 to 80 do
    begin
      TextColor(i mod 16);
      GotoXY(j, i);
      Write('a');
    end;
  Ramcek(1,24,1,80,7,0,200,'double');

  repeat
    SetTextDisp(X,Y);
    if KeyPressed then ch:=ReadKey;
    case klavesa(ch) of
      4:Dec(X,N);  6:Inc(X,N);      { Left,Right }
      8:Dec(Y,N);  2:Inc(Y,N);      { Up,Down }
    end;
    if X<0 then X:=0; if X>720 then X:=720;
    if Y<0 then Y:=0; if Y>500 then Y:=500;
  until ch = #27;
  SetTextDisp(0,0);
end;

begin
  Scroll;
end.
